//----------------------------------------------------------------
//	vector.cpp
//		VectorNX̒`
//----------------------------------------------------------------

#include	"vector.h"

//RXgN^
Vector::Vector(){
	for(	int	i=0;	i<VLEN;	i++){
		element[i]	=	0;
	}
}
Vector::Vector(	double	x	){
	for(	int	i=0;	i<VLEN;	i++){
		element[i]	=	x;
	}
}
Vector::Vector(	double	x,	double	y){
	element[0]	=	x;
	element[1]	=	y;
	if(	VLEN	>=3	){
		for(	int	i=2;	i<VLEN;	i++){
			element[i]	=	0;
		}
	}
}
Vector::Vector(	double	x,	double	y,	double	z=0){
	element[0]	=	x;
	element[1]	=	y;
	if(	VLEN	>=3	){
		element[2]	=	z;
	}
	for(	int	i=3;	i<VLEN;	i++){
		element[i]	=	0;
	}
}
	/*
	Dn搶
		pɒǉ܂B
		A3ȊOłȂȂ悤AHv܂B
	*/

//fBXgN^
Vector::~Vector(){
}

//o֐
double		Abs(	Vector&	v){
	//Βl
	double	ab=0;
	for(	int	i=0;	i<VLEN;	i++){
		ab	+=	v[i]*v[i];
	}
	ab	=	sqrt(ab);
	return	ab;
}
Vector		Unit(	Vector&	v){
	//PʃxNgϊ
	return	v/Abs(v);
}


//Zq̒`
ostream&	operator<<(	ostream& s,	Vector&	v1){
	for(	int	i=0;	i<VLEN;	i++){
		s	<<	v1[i]	<<	" ";
	}
}
istream&	operator>>(	istream& s,	Vector&	v1){
	for(	int	i=0;	i<VLEN;	i++){
		s	>>	v1[i];
	}
}
Vector		operator	+		(	Vector&	v1,	Vector&	v2	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	+	v2[i];
	}
	return	v;
}
Vector		operator	-		(	Vector&	v1	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	-v1[i];
	}
	return	v;
}
Vector		operator	-		(	Vector&	v1,	Vector&	v2	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	-	v2[i];
	}
	return	v;
}
Vector		operator	*		(	Vector&	v1,	double	d	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	*	d;
	}
	return	v;
}
Vector		operator	*		(	double	d,	Vector&	v1	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	*	d;
	}
	return	v;
}
Vector		operator	/		(	Vector&	v1,	double	d	){
	Vector	v;
	for(	int	i=0;	i<VLEN;	i++){
		v[i]	=	v1[i]	/	d;
	}
	return	v;
}
void			operator	+=	(	Vector&	v1,	Vector&	v2	){
	v1	=	v1+v2;
}
void			operator	-=	(	Vector&	v1,	Vector&	v2	){
	v1	=	v1-v2;
}
void			operator	*=	(	Vector&	v1,	double		d	){
	v1	=	v1*d;
}
void			operator	/=	(	Vector&	v1,	double		d	){
	v1	=	v1/d;
}
double		operator	*		(	Vector&	v1,	Vector&	v2	){
	//
	double	d=0;
	for(	int	i=0;	i<VLEN;	i++){
		d	+=	v1[i]*v2[i];
	}
	return	d;
}
Vector		operator	%		(	Vector&	v1,	Vector&	v2	){
	//O
	Vector	v;
	if(VLEN==3){
		v[0]=v1[1]*v2[2]-v1[2]*v2[1];
		v[1]=v1[2]*v2[0]-v1[0]*v2[2];
		v[2]=v1[0]*v2[1]-v1[1]*v2[0];
		return	v;
	}
	else{
		cout	<<	"`Ă܂"	<<	"\n";
		return	v;
	}
}
/*Dn搶
		Oς3ȊOŎgȂ̂ŁAVLEN3ł͗xNgԂ悤ɂ܂B
*/
int				operator	==	(	Vector&	v1,	Vector&	v2	){
	double	d=1;
	for(	int	i=0;	i<VLEN;	i++){
		d	*=	(	v1[i]	==	v2[i]	);
	}
	return	d;
}
void			operator	%=	(	Vector&	v1,	Vector&	v2	){
	//O
	v1	=	v1%v2;
}
